// Copyright (C) Microsoft. All rights reserved.
attribute vec3 vPosition0;
attribute vec2 vTexCoord0;
attribute vec2 vTexCoord1;
uniform mat4 Proj;
uniform mat4 View;
uniform vec3 Camera;
uniform float Near;
uniform float Far;
uniform mat4 World;
uniform float TextureScale;
uniform vec2 TextureOffset;
varying float vDistance;
void main()
{
vec4 position=World*vec4(vPosition0,1.0);
vDistance=length(Camera-position.xyz)/Far;
gl_Position=(Proj*View)*position;
}
