// Copyright (C) Microsoft. All rights reserved.
attribute vec3 vPosition0;
attribute vec3 vNormal;
attribute vec2 vTexCoord0;
attribute vec4 vColor;
varying vec2 v_texCoord;
uniform mat4 Proj;
uniform mat4 View;
uniform vec2 ViewSize;
uniform mat4 World;
uniform vec3 GlobalOff;
vec2 DecodeSides(float val)
{
float encoded=(val*1.0)/2.0;
float fraction=encoded-floor(encoded);
return vec2(fraction*2.0,floor(encoded));
}
void main()
{
vec2 decoded=DecodeSides(vColor.g);
vec2 tex=decoded*vec2(2.0,2.0)-vec2(1.0,1.0);
vec3 p0W=vPosition0+GlobalOff;
vec3 p1W=vNormal+GlobalOff;
vec3 normalW=normalize(cross(p0W,p1W));
float width=20.0;
vec3 normalWAdjusted=normalW*tex.x*tex.y;
vec3 pos=vPosition0+normalWAdjusted*width;
gl_Position=(Proj*(View*World))*vec4(pos,1.0);
gl_Position.z-=10.0;
v_texCoord=vec2(float(vTexCoord0.x)/32767.0,float(vTexCoord0.y)/32767.0);
}
