// Copyright (C) Microsoft. All rights reserved.
precision highp float;
uniform lowp sampler2D s_texture01;
varying vec2 v_texCoord;
uniform vec4 Color;
uniform vec4 BackgroundColor;
void main()
{
lowp vec4 textColor=texture2D(s_texture01,v_texCoord);
float alpha=Color.a*textColor.a;
vec3 bg=BackgroundColor.rgb*BackgroundColor.a;
float finalAlpha=alpha+BackgroundColor.a*(1.0-alpha);
vec3 color=bg*(1.0-alpha)+textColor.rgb*alpha;
gl_FragColor=vec4(color/finalAlpha,finalAlpha);
}
