// Copyright (C) Microsoft. All rights reserved.
precision highp float;
uniform lowp sampler2D s_texture01;
varying float vDistance;
void main()
{
float depthExpanded=vDistance*16777216.0;
float topSig=floor(depthExpanded/65536.0);
float middleTwo=depthExpanded-(topSig*65536.0);
float midSig=floor(middleTwo/256.0);
float lowSig=middleTwo-(midSig*256.0);
vec4 color=vec4(
topSig/255.0,
midSig/255.0,
lowSig/255.0,
1.0);
gl_FragColor=color;
}
